org.glassfish.jersey

## Class CommonProperties

- java.lang.Object
- - org.glassfish.jersey.CommonProperties

    public final class CommonProperties
    extends Object

Common (server/client) Jersey configuration properties.

Author:
  Michal Gajdos, Libor Kramolis

### Field Summary

Fields
`static String` `ALLOW_SYSTEM_PROPERTIES_PROVIDER` Property which allows (if true) default System properties configuration provider.
`static String` `FEATURE_AUTO_DISCOVERY_DISABLE` If `true` then disable feature auto discovery globally on client/server.
`static String` `FEATURE_AUTO_DISCOVERY_DISABLE_CLIENT` Client-specific version of `FEATURE_AUTO_DISCOVERY_DISABLE`.
`static String` `FEATURE_AUTO_DISCOVERY_DISABLE_SERVER` Server-specific version of `FEATURE_AUTO_DISCOVERY_DISABLE`.
`static String` `JSON_PROCESSING_FEATURE_DISABLE` If `true` then disable configuration of Json Processing (JSR-353) feature.
`static String` `JSON_PROCESSING_FEATURE_DISABLE_CLIENT` Client-specific version of `JSON_PROCESSING_FEATURE_DISABLE`.
`static String` `JSON_PROCESSING_FEATURE_DISABLE_SERVER` Server-specific version of `JSON_PROCESSING_FEATURE_DISABLE`.
`static String` `METAINF_SERVICES_LOOKUP_DISABLE` If `true` then disable META-INF/services lookup globally on client/server.
`static String` `METAINF_SERVICES_LOOKUP_DISABLE_CLIENT` Client-specific version of `METAINF_SERVICES_LOOKUP_DISABLE`.
`static String` `METAINF_SERVICES_LOOKUP_DISABLE_SERVER` Server-specific version of `METAINF_SERVICES_LOOKUP_DISABLE`.
`static String` `MOXY_JSON_FEATURE_DISABLE` If `true` then disable configuration of MOXy Json feature.
`static String` `MOXY_JSON_FEATURE_DISABLE_CLIENT` Client-specific version of `MOXY_JSON_FEATURE_DISABLE`.
`static String` `MOXY_JSON_FEATURE_DISABLE_SERVER` Server-specific version of `MOXY_JSON_FEATURE_DISABLE`.
`static String` `OUTBOUND_CONTENT_LENGTH_BUFFER` An integer value that defines the buffer size used to buffer the outbound message entity in order to determine its size and set the value of HTTP `"Content-Length"` header.
`static String` `OUTBOUND_CONTENT_LENGTH_BUFFER_CLIENT` Client-specific version of `OUTBOUND_CONTENT_LENGTH_BUFFER`.
`static String` `OUTBOUND_CONTENT_LENGTH_BUFFER_SERVER` Server-specific version of `OUTBOUND_CONTENT_LENGTH_BUFFER`.
`static String` `PROVIDER_DEFAULT_DISABLE` Disable some of the default providers from being loaded.

### Method Summary

All Methods Static Methods Concrete Methods
`static <T> T` `getValue(Map<String,?> properties, jakarta.ws.rs.RuntimeType runtime, String propertyName, Class<T> type)` Get the value of the specified property.
`static <T> T` `getValue(Map<String,?> properties, jakarta.ws.rs.RuntimeType runtime, String propertyName, T defaultValue)` Get the value of the specified property.
`static <T> T` `getValue(Map<String,?> properties, jakarta.ws.rs.RuntimeType runtime, String propertyName, T defaultValue, Class<T> type)` Get the value of the specified property.
`static Object` `getValue(Map<String,?> properties, String propertyName, Class<?> type)` Get the value of the specified property.
`static <T> T` `getValue(Map<String,?> properties, String propertyName, T defaultValue)` Get the value of the specified property.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### ALLOW_SYSTEM_PROPERTIES_PROVIDER

    public static final String ALLOW_SYSTEM_PROPERTIES_PROVIDER

Property which allows (if true) default System properties configuration provider. If an external properties provider is used, the system properties are not used. Shall be set to turn on the ability to propagate system properties to Jersey configuration.

Since:
  2.29
See Also:
  Constant Field Values

#### FEATURE_AUTO_DISCOVERY_DISABLE

    public static final String FEATURE_AUTO_DISCOVERY_DISABLE

If `true` then disable feature auto discovery globally on client/server.

By default auto discovery is automatically enabled. The value of this property may be overridden by the client/server variant of this property.

The default value is `false`.

The name of the configuration property is `"jersey.config.disableAutoDiscovery"`.

See Also:
  Constant Field Values

#### FEATURE_AUTO_DISCOVERY_DISABLE_CLIENT

    public static final String FEATURE_AUTO_DISCOVERY_DISABLE_CLIENT

Client-specific version of `FEATURE_AUTO_DISCOVERY_DISABLE`. If present, it overrides the generic one for the client environment.

Since:
  2.8
See Also:
  Constant Field Values

#### FEATURE_AUTO_DISCOVERY_DISABLE_SERVER

    public static final String FEATURE_AUTO_DISCOVERY_DISABLE_SERVER

Server-specific version of `FEATURE_AUTO_DISCOVERY_DISABLE`. If present, it overrides the generic one for the server environment.

Since:
  2.8
See Also:
  Constant Field Values

#### JSON_PROCESSING_FEATURE_DISABLE

    public static final String JSON_PROCESSING_FEATURE_DISABLE

If `true` then disable configuration of Json Processing (JSR-353) feature.

By default Json Processing is automatically enabled. The value of this property may be overridden by the client/server variant of this property.

The default value is `false`.

The name of the configuration property is `"jersey.config.disableJsonProcessing"`.

See Also:
  Constant Field Values

#### JSON_PROCESSING_FEATURE_DISABLE_CLIENT

    public static final String JSON_PROCESSING_FEATURE_DISABLE_CLIENT

Client-specific version of `JSON_PROCESSING_FEATURE_DISABLE`. If present, it overrides the generic one for the client environment.

Since:
  2.8
See Also:
  Constant Field Values

#### JSON_PROCESSING_FEATURE_DISABLE_SERVER

    public static final String JSON_PROCESSING_FEATURE_DISABLE_SERVER

Server-specific version of `JSON_PROCESSING_FEATURE_DISABLE`. If present, it overrides the generic one for the server environment.

Since:
  2.8
See Also:
  Constant Field Values

#### METAINF_SERVICES_LOOKUP_DISABLE

    public static final String METAINF_SERVICES_LOOKUP_DISABLE

If `true` then disable META-INF/services lookup globally on client/server.

By default Jersey looks up SPI implementations described by META-INF/services/* files. Then you can register appropriate provider classes by `Application`.

The default value is `false`.

The name of the configuration property is `"jersey.config.disableMetainfServicesLookup"`.

Since:
  2.1
See Also:
  Constant Field Values

#### METAINF_SERVICES_LOOKUP_DISABLE_CLIENT

    public static final String METAINF_SERVICES_LOOKUP_DISABLE_CLIENT

Client-specific version of `METAINF_SERVICES_LOOKUP_DISABLE`. If present, it overrides the generic one for the client environment.

Since:
  2.8
See Also:
  Constant Field Values

#### METAINF_SERVICES_LOOKUP_DISABLE_SERVER

    public static final String METAINF_SERVICES_LOOKUP_DISABLE_SERVER

Server-specific version of `METAINF_SERVICES_LOOKUP_DISABLE`. If present, it overrides the generic one for the server environment.

Since:
  2.8
See Also:
  Constant Field Values

#### MOXY_JSON_FEATURE_DISABLE

    public static final String MOXY_JSON_FEATURE_DISABLE

If `true` then disable configuration of MOXy Json feature.

By default MOXy Json is automatically enabled. The value of this property may be overridden by the client/server variant of this property.

The default value is `false`.

The name of the configuration property is `"jersey.config.disableMoxyJson"`.

See Also:
  Constant Field Values

#### MOXY_JSON_FEATURE_DISABLE_CLIENT

    public static final String MOXY_JSON_FEATURE_DISABLE_CLIENT

Client-specific version of `MOXY_JSON_FEATURE_DISABLE`. If present, it overrides the generic one for the client environment.

Since:
  2.8
See Also:
  Constant Field Values

#### MOXY_JSON_FEATURE_DISABLE_SERVER

    public static final String MOXY_JSON_FEATURE_DISABLE_SERVER

Server-specific version of `MOXY_JSON_FEATURE_DISABLE`. If present, it overrides the generic one for the server environment.

Since:
  2.8
See Also:
  Constant Field Values

#### OUTBOUND_CONTENT_LENGTH_BUFFER

    public static final String OUTBOUND_CONTENT_LENGTH_BUFFER

An integer value that defines the buffer size used to buffer the outbound message entity in order to determine its size and set the value of HTTP `"Content-Length"` header.

If the entity size exceeds the configured buffer size, the buffering would be cancelled and the entity size would not be determined. Value less or equal to zero disable the buffering of the entity at all.

The value of this property may be overridden by the client/server variant of this property by defining the suffix to this property "`.server`" or "`.client`" (`"jersey.config.contentLength.buffer".server` or `"jersey.config.contentLength.buffer".client`).

The default value is `8192`.

The name of the configuration property is `"jersey.config.contentLength.buffer"`.

See Also:
  Constant Field Values

#### OUTBOUND_CONTENT_LENGTH_BUFFER_CLIENT

    public static final String OUTBOUND_CONTENT_LENGTH_BUFFER_CLIENT

Client-specific version of `OUTBOUND_CONTENT_LENGTH_BUFFER`. If present, it overrides the generic one for the client environment.

Since:
  2.8
See Also:
  Constant Field Values

#### OUTBOUND_CONTENT_LENGTH_BUFFER_SERVER

    public static final String OUTBOUND_CONTENT_LENGTH_BUFFER_SERVER

Server-specific version of `OUTBOUND_CONTENT_LENGTH_BUFFER`. If present, it overrides the generic one for the server environment.

Since:
  2.8
See Also:
  Constant Field Values

#### PROVIDER_DEFAULT_DISABLE

    public static final String PROVIDER_DEFAULT_DISABLE

Disable some of the default providers from being loaded. The following providers extend application footprint by XML dependencies, which is too heavy for native image, or by AWT which may possibly be not available by JDK 11 desktop:

- java.awt.image.RenderedImage
- javax.xml.transform.Source
- javax.xml.transform.dom.DOMSource
- javax.xml.transform.sax.SAXSource
- javax.xml.transform.stream.StreamSource

The following are the options to disable the provides: `DOMSOURCE, RENDEREDIMAGE, SAXSOURCE, SOURCE, STREAMSOURCE`, or to disable all: `ALL`. Multiple options can be disabled by adding multiple comma separated values.

Since:
  2.30
See Also:
  Constant Field Values

### Method Detail

#### getValue

    public static Object getValue(Map<String,?> properties,
                                  String propertyName,
                                  Class<?> type)

Get the value of the specified property. If the property is not set or the actual property value type is not compatible with the specified type, the method will return `null`.

Parameters:
  `properties` - Map of properties to get the property value from.
  `propertyName` - Name of the property.
  `type` - Type to retrieve the value as.
Returns:
  Value of the property or `null`.
Since:
  2.8

#### getValue

    public static <T> T getValue(Map<String,?> properties,
                                 String propertyName,
                                 T defaultValue)

Get the value of the specified property. If the property is not set or the real value type is not compatible with `defaultValue` type, the specified `defaultValue` is returned. Calling this method is equivalent to calling `CommonProperties.getValue(properties, key, defaultValue, (Class&lt;T&gt;) defaultValue.getClass())`

Type Parameters:
  `T` - Type of the property value.
Parameters:
  `properties` - Map of properties to get the property value from.
  `propertyName` - Name of the property.
  `defaultValue` - Default value if property is not registered
Returns:
  Value of the property or `null`.
Since:
  2.8

#### getValue

    public static <T> T getValue(Map<String,?> properties,
                                 jakarta.ws.rs.RuntimeType runtime,
                                 String propertyName,
                                 T defaultValue)

Get the value of the specified property. If the property is not set or the real value type is not compatible with `defaultValue` type, the specified `defaultValue` is returned. Calling this method is equivalent to calling `CommonProperties.getValue(properties, runtimeType, key, defaultValue, (Class&lt;T&gt;) defaultValue.getClass())`

Type Parameters:
  `T` - Type of the property value.
Parameters:
  `properties` - Map of properties to get the property value from.
  `runtime` - Runtime type which is used to check whether there is a property with the same `key` but post-fixed by runtime type (`.server` or `.client`) which would override the `key` property.
  `propertyName` - Name of the property.
  `defaultValue` - Default value if property is not registered
Returns:
  Value of the property or `null`.
Since:
  2.8

#### getValue

    public static <T> T getValue(Map<String,?> properties,
                                 jakarta.ws.rs.RuntimeType runtime,
                                 String propertyName,
                                 T defaultValue,
                                 Class<T> type)

Get the value of the specified property. If the property is not set or the real value type is not compatible with the specified value type, returns `defaultValue`.

Type Parameters:
  `T` - Type of the property value.
Parameters:
  `properties` - Map of properties to get the property value from.
  `runtime` - Runtime type which is used to check whether there is a property with the same `key` but post-fixed by runtime type (`.server` or `.client`) which would override the `key` property.
  `propertyName` - Name of the property.
  `defaultValue` - Default value if property is not registered
  `type` - Type to retrieve the value as.
Returns:
  Value of the property or `null`.
Since:
  2.8

#### getValue

    public static <T> T getValue(Map<String,?> properties,
                                 jakarta.ws.rs.RuntimeType runtime,
                                 String propertyName,
                                 Class<T> type)

Get the value of the specified property. If the property is not set or the actual property value type is not compatible with the specified type, the method will return `null`.

Type Parameters:
  `T` - Type of the property value.
Parameters:
  `properties` - Map of properties to get the property value from.
  `runtime` - Runtime type which is used to check whether there is a property with the same `key` but post-fixed by runtime type (`.server` or `.client`) which would override the `key` property.
  `propertyName` - Name of the property.
  `type` - Type to retrieve the value as.
Returns:
  Value of the property or `null`.
Since:
  2.8